Searcher (Lucene 2.4.1 API)
Keywords: org.apache.lucene.search.Searcher class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class Searcher

    java.lang.Object
      org.apache.lucene.search.Searcher

All Implemented Interfaces:
  Remote, Searchable

Direct Known Subclasses:
  IndexSearcher, MultiSearcher

    public abstract class Searcher

extends Object
implements Searchable

An abstract base class for search implementations. Implements the main search methods.

Note that you can only access Hits from a Searcher as long as it is not yet closed, otherwise an IOException will be thrown.

Constructor Summary
`Searcher()`

Method Summary
`abstract void` | `close()` Frees resources associated with this Searcher.
`protected Weight` | `createWeight(Query query)` creates a weight for `query`
`abstract Document` | `doc(int i)` Expert: Returns the stored fields of document `i`.
`abstract int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
`int[]` | `docFreqs(Term[] terms)` Expert: For each term in the terms array, calculates the number of documents containing `term`.
`Explanation` | `explain(Query query, int doc)` Returns an Explanation that describes how `doc` scored against `query`.
`abstract Explanation` | `explain(Weight weight, int doc)` Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.
`Similarity` | `getSimilarity()` Expert: Return the Similarity implementation used by this Searcher.
`abstract int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
`abstract Query` | `rewrite(Query query)` Expert: called to re-write queries into primitive queries.
`Hits` | `search(Query query)` Deprecated. Hits will be removed in Lucene 3.0. Use `search(Query, Filter, int)` instead.
`Hits` | `search(Query query, Filter filter)` Deprecated. Hits will be removed in Lucene 3.0. Use `search(Query, Filter, int)` instead.
`void` | `search(Query query, Filter filter, HitCollector results)` Lower-level search API.
`TopDocs` | `search(Query query, Filter filter, int n)` Finds the top `n` hits for `query`, applying `filter` if non-null.
`TopFieldDocs` | `search(Query query, Filter filter, int n, Sort sort)` Search implementation with arbitrary sorting.
`Hits` | `search(Query query, Filter filter, Sort sort)` Deprecated. Hits will be removed in Lucene 3.0. Use `search(Query, Filter, int, Sort)` instead.
`void` | `search(Query query, HitCollector results)` Lower-level search API.
`TopDocs` | `search(Query query, int n)` Finds the top `n` hits for `query`.
`Hits` | `search(Query query, Sort sort)` Deprecated. Hits will be removed in Lucene 3.0. Use `search(Query, Filter, int, Sort)` instead.
`abstract void` | `search(Weight weight, Filter filter, HitCollector results)` Lower-level search API.
`abstract TopDocs` | `search(Weight weight, Filter filter, int n)` Expert: Low-level search implementation.
`abstract TopFieldDocs` | `search(Weight weight, Filter filter, int n, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.
`void` | `setSimilarity(Similarity similarity)` Expert: Set the Similarity implementation used by this Searcher.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.lucene.search.Searchable
`doc`

Constructor Detail

### Searcher

    public Searcher()

Method Detail

### search

    public final Hits search(Query query)
                      throws IOException

  Deprecated. Hits will be removed in Lucene 3.0. Use `search(Query, Filter, int)` instead.

  Returns the documents matching `query`.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public Hits search(Query query,
                       Filter filter)
                throws IOException

  Deprecated. Hits will be removed in Lucene 3.0. Use `search(Query, Filter, int)` instead.

  Returns the documents matching `query` and `filter`.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public Hits search(Query query,
                       Sort sort)
                throws IOException

  Deprecated. Hits will be removed in Lucene 3.0. Use `search(Query, Filter, int, Sort)` instead.

  Returns documents matching `query` sorted by `sort`.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public Hits search(Query query,
                       Filter filter,
                       Sort sort)
                throws IOException

  Deprecated. Hits will be removed in Lucene 3.0. Use `search(Query, Filter, int, Sort)` instead.

  Returns documents matching `query` and `filter`, sorted by `sort`.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public TopFieldDocs search(Query query,
                               Filter filter,
                               int n,
                               Sort sort)
                        throws IOException

  Search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `search(Query,Filter,Sort)` instead.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public void search(Query query,
                       HitCollector results)
                throws IOException

  Lower-level search API.

  `HitCollector.collect(int,float)` is called for every matching document.

  Applications should only use this if they need all of the matching documents. The high-level search API (`search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

  Note: The `score` passed to this method is a raw score. In other words, the score will not necessarily be a float whose value is between 0 and 1.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public void search(Query query,
                       Filter filter,
                       HitCollector results)
                throws IOException

  Lower-level search API.

  `HitCollector.collect(int,float)` is called for every matching document.
  HitCollector-based access to remote indexes is discouraged.

  Applications should only use this if they need all of the matching documents. The high-level search API (`search(Query, Filter, int)`) is usually more efficient, as it skips non-high-scoring hits.

  Parameters:
    `query` - to match documents
    `filter` - if non-null, used to permit documents to be collected.
    `results` - to receive hits
  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public TopDocs search(Query query,
                          Filter filter,
                          int n)
                   throws IOException

  Finds the top `n` hits for `query`, applying `filter` if non-null.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public TopDocs search(Query query,
                          int n)
                   throws IOException

  Finds the top `n` hits for `query`.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### explain

    public Explanation explain(Query query,
                               int doc)
                        throws IOException

  Returns an Explanation that describes how `doc` scored against `query`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Throws:
    `IOException`

### setSimilarity

    public void setSimilarity(Similarity similarity)

  Expert: Set the Similarity implementation used by this Searcher.

  See Also:
    `Similarity.setDefault(Similarity)`

### getSimilarity

    public Similarity getSimilarity()

  Expert: Return the Similarity implementation used by this Searcher.

  This defaults to the current value of `Similarity.getDefault()`.

### createWeight

    protected Weight createWeight(Query query)
                           throws IOException

  creates a weight for `query`

  Returns:
    new weight
  Throws:
    `IOException`

### docFreqs

    public int[] docFreqs(Term[] terms)
                   throws IOException

  Description copied from interface: `Searchable`
  Expert: For each term in the terms array, calculates the number of documents containing `term`. Returns an array with these document frequencies. Used to minimize number of remote calls.

  Specified by:
    `docFreqs` in interface `Searchable`
  Throws:
    `IOException`

### search

    public abstract void search(Weight weight,
                                Filter filter,
                                HitCollector results)
                         throws IOException

  Description copied from interface: `Searchable`
  Lower-level search API.

  `HitCollector.collect(int,float)` is called for every non-zero scoring document.
  HitCollector-based access to remote indexes is discouraged.

  Applications should only use this if they need all of the matching documents. The high-level search API (`search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

  Specified by:
    `search` in interface `Searchable`
  Parameters:
    `weight` - to match documents
    `filter` - if non-null, used to permit documents to be collected.
    `results` - to receive hits
  Throws:
    `IOException`

### close

    public abstract void close()
                        throws IOException

  Description copied from interface: `Searchable`
  Frees resources associated with this Searcher. Be careful not to call this method while you are still using objects like `Hits`.

  Specified by:
    `close` in interface `Searchable`
  Throws:
    `IOException`

### docFreq

    public abstract int docFreq(Term term)
                         throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns the number of documents containing `term`. Called by search code to compute term weights.

  Specified by:
    `docFreq` in interface `Searchable`
  Throws:
    `IOException`
  See Also:
    `IndexReader.docFreq(Term)`

### maxDoc

    public abstract int maxDoc()
                        throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns one greater than the largest possible document number. Called by search code to compute term weights.

  Specified by:
    `maxDoc` in interface `Searchable`
  Throws:
    `IOException`
  See Also:
    `IndexReader.maxDoc()`

### search

    public abstract TopDocs search(Weight weight,
                                   Filter filter,
                                   int n)
                            throws IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

  Called by `Hits`.

  Applications should usually call `search(Query)` or `search(Query,Filter)` instead.

  Specified by:
    `search` in interface `Searchable`
  Throws:
    `IOException`

### doc

    public abstract Document doc(int i)
                          throws CorruptIndexException,
                                 IOException

  Description copied from interface: `Searchable`
  Expert: Returns the stored fields of document `i`. Called by `HitCollector` implementations.

  Specified by:
    `doc` in interface `Searchable`
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int)`

### rewrite

    public abstract Query rewrite(Query query)
                           throws IOException

  Description copied from interface: `Searchable`
  Expert: called to re-write queries into primitive queries.

  Specified by:
    `rewrite` in interface `Searchable`
  Throws:
    `IOException`

### explain

    public abstract Explanation explain(Weight weight,
                                        int doc)
                                 throws IOException

  Description copied from interface: `Searchable`
  Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Applications should call `explain(Query, int)`.

  Specified by:
    `explain` in interface `Searchable`
  Throws:
    `IOException`

### search

    public abstract TopFieldDocs search(Weight weight,
                                        Filter filter,
                                        int n,
                                        Sort sort)
                                 throws IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `search(Query,Filter,Sort)` instead.

  Specified by:
    `search` in interface `Searchable`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.